diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/GroupKey.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/GroupKey.java
new file mode 100644
index 000000000..982f43015
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/GroupKey.java
@@ -0,0 +1,153 @@
+package net.minecraft.client.gui.keyboard.keys;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.keyboard.ScreenKeyboard;
+
+import java.lang.reflect.Type;
+import java.util.Locale;
+
+public class GroupKey extends Key{
+    protected final Mode mode;
+    protected final int amount;
+    protected final int amount2;
+    public GroupKey(int x, int y, int width, int height, Mode mode, int amount, int amount2) {
+        super(x, y, width, height);
+        this.mode = mode;
+        this.amount = amount;
+        this.amount2 = amount2;
+    }
+
+    @Override
+    public void pressAction(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
+        super.pressAction(mc, keyboard, originX, originY, mouseX, mouseY);
+        switch (mode) {
+            case OFFSET:
+                keyboard.shiftGroup(amount);
+                break;
+            case SET:
+                keyboard.setGroup(amount);
+                break;
+            case TOGGLE:
+                if (keyboard.getGroup() == amount) {
+                    keyboard.setGroup(amount2);
+                } else {
+                    keyboard.setGroup(amount);
+                }
+        }
+    }
+
+    public enum Mode {
+        SET,
+        OFFSET,
+        TOGGLE;
+    }
+
+    public static class Serializer implements JsonSerializer<GroupKey>, JsonDeserializer<GroupKey> {
+        public static final int DEFAULT_WIDTH = 18;
+        public static final int DEFAULT_HEIGHT = 18;
+
+        public static final String DEFAULT_TEXTURE_NEXT_UP = "minecraft:gui/widgets/keyboard/key_page_next/up";
+        public static final String DEFAULT_TEXTURE_NEXT_DOWN = "minecraft:gui/widgets/keyboard/key_page_next/down";
+        public static final String DEFAULT_TEXTURE_NEXT_UP_HOVERED = "minecraft:gui/widgets/keyboard/key_page_next/up_hovered";
+        public static final String DEFAULT_TEXTURE_NEXT_DOWN_HOVERED = "minecraft:gui/widgets/keyboard/key_page_next/down_hovered";
+
+        public static final String DEFAULT_TEXTURE_LAST_UP = "minecraft:gui/widgets/keyboard/key_page_last/up";
+        public static final String DEFAULT_TEXTURE_LAST_DOWN = "minecraft:gui/widgets/keyboard/key_page_last/down";
+        public static final String DEFAULT_TEXTURE_LAST_UP_HOVERED = "minecraft:gui/widgets/keyboard/key_page_last/up_hovered";
+        public static final String DEFAULT_TEXTURE_LAST_DOWN_HOVERED = "minecraft:gui/widgets/keyboard/key_page_last/down_hovered";
+
+        public static final Mode DEFAULT_MODE = Mode.OFFSET;
+
+        @Override
+        public GroupKey deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+            JsonObject obj = json.getAsJsonObject();
+            int x = obj.get("x").getAsInt();
+            int y = obj.get("y").getAsInt();
+            int width = obj.has("width") ? obj.get("width").getAsInt() : DEFAULT_WIDTH;
+            int height = obj.has("height") ? obj.get("height").getAsInt() : DEFAULT_HEIGHT;
+            ButtonEnum button = obj.has("button") ? Key.ButtonEnum.valueOf(obj.get("button").getAsString().toUpperCase(Locale.ROOT)) : null;
+
+            Mode mode = obj.has("mode") ? Mode.valueOf(obj.get("mode").getAsString().toUpperCase(Locale.ROOT)) : DEFAULT_MODE;
+
+            int lowest;
+            int highest;
+
+            switch (mode) {
+                case TOGGLE:
+                    lowest = obj.get("page1").getAsInt();
+                    highest = obj.get("page2").getAsInt();
+                    break;
+                case SET:
+                case OFFSET:
+                default:
+                    highest = lowest = obj.get("amount").getAsInt();;
+                    break;
+            }
+
+            String texUp = lowest >= 0 ? DEFAULT_TEXTURE_NEXT_UP : DEFAULT_TEXTURE_LAST_UP;
+            String texDown = lowest >= 0 ? DEFAULT_TEXTURE_NEXT_DOWN : DEFAULT_TEXTURE_LAST_DOWN;
+            String texUpHovered = lowest >= 0 ? DEFAULT_TEXTURE_NEXT_UP_HOVERED : DEFAULT_TEXTURE_LAST_UP_HOVERED;
+            String texDownHovered = lowest >= 0 ? DEFAULT_TEXTURE_NEXT_DOWN_HOVERED : DEFAULT_TEXTURE_LAST_DOWN_HOVERED;
+
+            if (obj.has("textures")) {
+                JsonObject textures = obj.getAsJsonObject("textures");
+                if (textures.has("up")) texUp = textures.get("up").getAsString();
+                if (textures.has("down")) texDown = textures.get("down").getAsString();
+                if (textures.has("up_hovered")) texUpHovered = textures.get("up_hovered").getAsString();
+                if (textures.has("down_hovered")) texDownHovered = textures.get("down_hovered").getAsString();
+            }
+            GroupKey key = new GroupKey(x, y, width, height, mode, lowest, highest);
+            key.setTextures(texUp, texDown, texUpHovered, texDownHovered);
+            key.setControllerButton(button);
+            return key;
+        }
+
+        @Override
+        public JsonElement serialize(GroupKey src, Type typeOfSrc, JsonSerializationContext context) {
+            JsonObject object = new JsonObject();
+            object.addProperty("type", Key.Serializer.KEY_CLASS_TO_ID.get(src.getClass()));
+
+            object.addProperty("x", src.x);
+            object.addProperty("y", src.y);
+            if (src.width != DEFAULT_WIDTH) object.addProperty("width", src.width);
+            if (src.height != DEFAULT_HEIGHT) object.addProperty("height", src.height);
+            if (src.controllerButton != null) object.addProperty("button", src.controllerButton.name().toLowerCase(Locale.ROOT));
+
+            boolean ku = true;
+            boolean kd = true;
+            boolean kuh = true;
+            boolean kdh = true;
+            if (ku || kd || kuh || kdh) {
+                JsonObject textureObject = new JsonObject();
+                if (ku) textureObject.addProperty("up", src.keyUp.sourceNamespaceId.toString());
+                if (kd) textureObject.addProperty("down", src.keyDown.sourceNamespaceId.toString());
+                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.sourceNamespaceId.toString());
+                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.sourceNamespaceId.toString());
+                object.add("textures", textureObject);
+            }
+
+            object.addProperty("mode", src.mode.name().toLowerCase(Locale.ROOT));
+
+            switch (src.mode) {
+                case TOGGLE:
+                    object.addProperty("page1", src.amount);
+                    object.addProperty("page2", src.amount2);
+                    break;
+                case SET:
+                case OFFSET:
+                default:
+                    object.addProperty("amount", src.amount);
+                    break;
+            }
+
+            return object;
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/Key.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/Key.java
new file mode 100644
index 000000000..671b6cca5
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/Key.java
@@ -0,0 +1,290 @@
+package net.minecraft.client.gui.keyboard.keys;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.ControllerGlyphElement;
+import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.GuiElement;
+import net.minecraft.client.gui.keyboard.ScreenKeyboard;
+import net.minecraft.client.input.InputType;
+import net.minecraft.client.input.controller.ControllerInput;
+import net.minecraft.client.input.controller.IButton;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.sound.SoundCategory;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.opengl.GL11;
+
+import java.lang.reflect.Type;
+import java.util.HashMap;
+import java.util.Map;
+
+public abstract class Key extends Gui implements GuiElement {
+    protected IconCoordinate keyUp = TextureRegistry.getTexture("minecraft:gui/widgets/keyboard/key/up");
+    protected IconCoordinate keyDown = TextureRegistry.getTexture("minecraft:gui/widgets/keyboard/key/down");
+    protected IconCoordinate keyUpHovered = TextureRegistry.getTexture("minecraft:gui/widgets/keyboard/key/up_hovered");
+    protected IconCoordinate keyDownHovered = TextureRegistry.getTexture("minecraft:gui/widgets/keyboard/key/down_hovered");
+
+    protected int x;
+    protected int y;
+    protected int width;
+    protected int height;
+
+    protected boolean isDown = false;
+    protected boolean isHovered = false;
+    protected long holdStart = 0;
+
+    protected @Nullable ButtonEnum controllerButton = null;
+
+    public Key() {
+
+    }
+
+    public Key(int x, int y, int width, int height) {
+        setPosition(x, y, width, height);
+    }
+
+    public void onOpen(Minecraft mc, ScreenKeyboard keyboard) {
+        isDown = false;
+        isHovered = false;
+    }
+    public void render(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
+        boolean hovered = isHovered(originX, originY, mouseX, mouseY);
+        if (!isHovered && hovered) {
+            onFocus(mc, keyboard, originX, originY, mouseX, mouseY);
+        }
+        isHovered = hovered;
+
+        boolean down = isDown(mc, keyboard);
+        if (down) {
+            if (hovered) {
+                drawGuiIcon(x + originX, y + originY, width, height, keyDownHovered);
+            } else {
+                drawGuiIcon(x + originX, y + originY, width, height, keyDown);
+            }
+        } else {
+            if (hovered) {
+                drawGuiIcon(x + originX, y + originY, width, height, keyUpHovered);
+            } else {
+                drawGuiIcon(x + originX, y + originY, width, height, keyUp);
+            }
+        }
+        if (mc.inputType == InputType.CONTROLLER && controllerButton != null) {
+            GL11.glPushMatrix();
+            GL11.glEnable(GL11.GL_BLEND);
+            GL11.glTranslatef(x + originX + width - 8, y + originY + 1, 0);
+            GL11.glColor4f(1, 1, 1, 0.5f);
+            GL11.glScalef(0.5f, 0.5f, 1);
+            keyboard.glyphRenderer.drawGlyph(mc.controllerInput, controllerButton.glyph, 0, 0);
+            GL11.glDisable(GL11.GL_BLEND);
+            GL11.glPopMatrix();
+        }
+    }
+
+    public void onFocus(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
+        mc.sndManager.playSound("ui.ui_focus", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
+    }
+
+    public void onClick(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY, int mouseButton) {
+        if (mouseButton == 0 && isHovered(originX, originY, mouseX, mouseY)) {
+            pressAction(mc, keyboard, originX, originY, mouseX, mouseY);
+            holdStart = System.currentTimeMillis();
+            isDown = true;
+        }
+    }
+
+    public void pressAction(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
+        mc.sndManager.playSound("ui.ui_click", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
+        if (mc.inputType == InputType.CONTROLLER && mc.controllerInput != null) {
+            mc.controllerInput.lockCursor = true;
+            mc.controllerInput.hideCursor = true;
+        }
+    }
+
+    public void releaseAction(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
+        if (mc.inputType == InputType.CONTROLLER && mc.controllerInput != null) {
+            mc.controllerInput.lockCursor = false;
+            mc.controllerInput.hideCursor = false;
+        }
+    }
+
+    public void onRelease(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY, int mouseButton) {
+        if (isDown && mouseButton == 0) {
+            releaseAction(mc, keyboard, originX, originY, mouseX, mouseY);
+            isDown = false;
+        }
+    }
+
+    public void onButtonUse(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY) {
+        if (mc.inputType == InputType.CONTROLLER && mc.controllerInput != null && controllerButton != null) {
+            IButton button = controllerButton.getButton(mc.controllerInput);
+            if (button.pressedThisFrame()) {
+                pressAction(mc, keyboard, originX, originY, (int) mc.controllerInput.cursorX, (int) mc.controllerInput.cursorY);
+                holdStart = System.currentTimeMillis();
+                isDown = true;
+            }
+            if (button.releasedThisFrame()) {
+                releaseAction(mc, keyboard, originX, originY, (int) mc.controllerInput.cursorX, (int) mc.controllerInput.cursorY);
+                isDown = false;
+            }
+        }
+    }
+
+    public Key setTextures(String keyUp, String keyDown, String keyUpHovered, String keyDownHovered) {
+        this.keyUp = TextureRegistry.getTexture(keyUp);
+        this.keyDown = TextureRegistry.getTexture(keyDown);
+        this.keyUpHovered = TextureRegistry.getTexture(keyUpHovered);
+        this.keyDownHovered = TextureRegistry.getTexture(keyDownHovered);
+        return this;
+    }
+
+    public Key setControllerButton(ButtonEnum button) {
+        this.controllerButton = button;
+        return this;
+    }
+
+    public long getHoldTime() {
+        return isDown ? System.currentTimeMillis() - holdStart : 0;
+    }
+
+    @Override
+    public void setX(int x) {
+        this.x = x;
+    }
+
+    @Override
+    public void setY(int y) {
+        this.y = y;
+    }
+
+    @Override
+    public void setWidth(int width) {
+        this.width = width;
+    }
+
+    @Override
+    public void setHeight(int height) {
+        this.height = height;
+    }
+
+    @Override
+    public int getX() {
+        return x;
+    }
+
+    @Override
+    public int getY() {
+        return y;
+    }
+
+    @Override
+    public int getWidth() {
+        return width;
+    }
+
+    @Override
+    public int getHeight() {
+        return height;
+    }
+
+    public boolean isHovered(int originX, int originY, int mx, int my) {
+        mx -= originX;
+        my -= originY;
+        return
+            x <= mx && mx < x + width &&
+            y <= my && my < y + height;
+    }
+
+    public boolean isDown(Minecraft mc, ScreenKeyboard keyboard) {
+        return isDown || isButtonPressed(mc, keyboard);
+    }
+
+    public boolean isButtonPressed(Minecraft mc, ScreenKeyboard keyboard) {
+        return mc.inputType == InputType.CONTROLLER && controllerButton != null && mc.controllerInput != null && controllerButton.getButton(mc.controllerInput).isPressed();
+    }
+
+    public int highestGroup() {
+        return 0;
+    }
+
+    public static class Serializer implements JsonSerializer<Key>, JsonDeserializer<Key> {
+        public static final Map<String, Class<? extends Key>> ID_TO_KEY_CLASS = new HashMap<>();
+        public static final Map<Class<? extends Key>, String> KEY_CLASS_TO_ID = new HashMap<>();
+        static {
+            registerKeyClass("key_char", CharKey.class);
+            registerKeyClass("key_back", BackspaceKey.class);
+            registerKeyClass("key_enter", EnterKey.class);
+            registerKeyClass("key_mod", ModifierKey.class);
+            registerKeyClass("key_group", GroupKey.class);
+            registerKeyClass("key_cursor", CursorKey.class);
+        }
+
+        public static void registerKeyClass(String id, Class<? extends Key> keyClass) {
+            assert !ID_TO_KEY_CLASS.containsKey(id) : "Id '" + id + "' is already assigned to class '" + ID_TO_KEY_CLASS.get(id).getSimpleName() + "'!";
+            assert !KEY_CLASS_TO_ID.containsKey(keyClass) : "Class '" + keyClass.getSimpleName() + "' is already assigned to id '" + KEY_CLASS_TO_ID.get(keyClass) + "'!";
+            ID_TO_KEY_CLASS.put(id, keyClass);
+            KEY_CLASS_TO_ID.put(keyClass, id);
+        }
+
+        @Override
+        public Key deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+            String type = json.getAsJsonObject().get("type").getAsString();
+            Class<? extends Key> keyClass = ID_TO_KEY_CLASS.get(type);
+            if (keyClass == null) {
+                throw new JsonParseException("No assigned key class for type '" + type + "'!");
+            }
+            return context.deserialize(json, keyClass);
+        }
+
+        @Override
+        public JsonElement serialize(Key src, Type typeOfSrc, JsonSerializationContext context) {
+            return null;
+        }
+    }
+
+    public enum ButtonEnum {
+        BUTTON_A(ControllerGlyphElement.Glyph.BUTTON_A, c -> c.buttonA),
+        BUTTON_B(ControllerGlyphElement.Glyph.BUTTON_B, c -> c.buttonB),
+        BUTTON_X(ControllerGlyphElement.Glyph.BUTTON_X, c -> c.buttonX),
+        BUTTON_Y(ControllerGlyphElement.Glyph.BUTTON_Y, c -> c.buttonY),
+
+        BUTTON_DPAD_UP(ControllerGlyphElement.Glyph.D_PAD_UP,c -> c.digitalPad.up),
+        BUTTON_DPAD_LEFT(ControllerGlyphElement.Glyph.D_PAD_LEFT,c -> c.digitalPad.left),
+        BUTTON_DPAD_DOWN(ControllerGlyphElement.Glyph.D_PAD_DOWN,c -> c.digitalPad.down),
+        BUTTON_DPAD_RIGHT(ControllerGlyphElement.Glyph.D_PAD_RIGHT,c -> c.digitalPad.right),
+
+        BUTTON_SHOULDER_LEFT(ControllerGlyphElement.Glyph.SHOULDER_LEFT,c -> c.buttonLeftShoulder),
+        BUTTON_SHOULDER_RIGHT(ControllerGlyphElement.Glyph.SHOULDER_RIGHT,c -> c.buttonRightShoulder),
+
+        BUTTON_STICK_LEFT(ControllerGlyphElement.Glyph.STICK_LEFT_PRESS,c -> c.joyLeft.button),
+        BUTTON_STICK_RIGHT(ControllerGlyphElement.Glyph.STICK_RIGHT_PRESS,c -> c.joyRight.button),
+
+        BUTTON_TRIGGER_LEFT(ControllerGlyphElement.Glyph.TRIGGER_LEFT,c -> c.buttonLeftTrigger),
+        BUTTON_TRIGGER_RIGHT(ControllerGlyphElement.Glyph.TRIGGER_RIGHT,c -> c.buttonRightTrigger),
+
+        BUTTON_START(ControllerGlyphElement.Glyph.BUTTON_START,c -> c.buttonStart),
+        BUTTON_BACK(ControllerGlyphElement.Glyph.BUTTON_BACK, c -> c.buttonBack);
+
+        public final @NotNull ControllerGlyphElement.Glyph glyph;
+        private final @NotNull ButtonGetter buttonGetter;
+
+        ButtonEnum(@NotNull ControllerGlyphElement.Glyph glyph, @NotNull ButtonGetter buttonGetter) {
+            this.glyph = glyph;
+            this.buttonGetter = buttonGetter;
+        }
+
+        public @NotNull IButton getButton(ControllerInput controller) {
+            return buttonGetter.apply(controller);
+        }
+
+        private interface ButtonGetter {
+            @NotNull IButton apply(@NotNull ControllerInput controller);
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/ModifierKey.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/ModifierKey.java
new file mode 100644
index 000000000..758ea48f0
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/ModifierKey.java
@@ -0,0 +1,118 @@
+package net.minecraft.client.gui.keyboard.keys;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.keyboard.ScreenKeyboard;
+
+import java.lang.reflect.Type;
+import java.util.Locale;
+
+public class ModifierKey extends Key{
+    public static final String ID_MODIFIER_SHIFT = "mod_shift";
+
+    protected final boolean locking;
+    protected final String modifierId;
+    public ModifierKey(int x, int y, int width, int height, String modifierId, boolean locking) {
+        super(x, y, width, height);
+        this.locking = locking;
+        this.modifierId = modifierId;
+        setTextures(
+            "minecraft:gui/widgets/keyboard/key_shift/up",
+            "minecraft:gui/widgets/keyboard/key_shift/down",
+            "minecraft:gui/widgets/keyboard/key_shift/up_hovered",
+            "minecraft:gui/widgets/keyboard/key_shift/down_hovered");
+    }
+
+    @Override
+    public void pressAction(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
+        super.pressAction(mc, keyboard, originX, originY, mouseX, mouseY);
+        if (locking) {
+            keyboard.setModifierLock(modifierId, !keyboard.isModifierLocked(modifierId));
+        } else {
+            keyboard.setModifierState(modifierId, !keyboard.isModifierActive(modifierId));
+        }
+    }
+
+    @Override
+    public boolean isDown(Minecraft mc, ScreenKeyboard keyboard) {
+        return super.isDown(mc, keyboard) || (locking ? keyboard.isModifierLocked(modifierId) : keyboard.activeModifiers.getOrDefault(modifierId, false));
+    }
+
+    public static class Serializer implements JsonSerializer<ModifierKey>, JsonDeserializer<ModifierKey> {
+        public static final int DEFAULT_WIDTH = 25;
+        public static final int DEFAULT_HEIGHT = 18;
+
+        public static final boolean DEFAULT_LOCKING = false;
+        public static final String DEFAULT_MODIFIER_ID = ID_MODIFIER_SHIFT;
+
+        public static final String DEFAULT_TEXTURE_UP = "minecraft:gui/widgets/keyboard/key_shift/up";
+        public static final String DEFAULT_TEXTURE_DOWN = "minecraft:gui/widgets/keyboard/key_shift/down";
+        public static final String DEFAULT_TEXTURE_UP_HOVERED = "minecraft:gui/widgets/keyboard/key_shift/up_hovered";
+        public static final String DEFAULT_TEXTURE_DOWN_HOVERED = "minecraft:gui/widgets/keyboard/key_shift/down_hovered";
+
+        @Override
+        public ModifierKey deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+            JsonObject obj = json.getAsJsonObject();
+            int x = obj.get("x").getAsInt();
+            int y = obj.get("y").getAsInt();
+            int width = obj.has("width") ? obj.get("width").getAsInt() : DEFAULT_WIDTH;
+            int height = obj.has("height") ? obj.get("height").getAsInt() : DEFAULT_HEIGHT;
+            ButtonEnum button = obj.has("button") ? Key.ButtonEnum.valueOf(obj.get("button").getAsString().toUpperCase(Locale.ROOT)) : null;
+
+            boolean locking = obj.has("toggle") ? obj.get("toggle").getAsBoolean() : DEFAULT_LOCKING;
+            String modId = obj.has("modifier") ? obj.get("modifier").getAsString() : DEFAULT_MODIFIER_ID;
+
+            String texUp = DEFAULT_TEXTURE_UP;
+            String texDown = DEFAULT_TEXTURE_DOWN;
+            String texUpHovered = DEFAULT_TEXTURE_UP_HOVERED;
+            String texDownHovered = DEFAULT_TEXTURE_DOWN_HOVERED;
+
+            if (obj.has("textures")) {
+                JsonObject textures = obj.getAsJsonObject("textures");
+                if (textures.has("up")) texUp = textures.get("up").getAsString();
+                if (textures.has("down")) texDown = textures.get("down").getAsString();
+                if (textures.has("up_hovered")) texUpHovered = textures.get("up_hovered").getAsString();
+                if (textures.has("down_hovered")) texDownHovered = textures.get("down_hovered").getAsString();
+            }
+            ModifierKey key = new ModifierKey(x, y, width, height, modId, locking);
+            key.setTextures(texUp, texDown, texUpHovered, texDownHovered);
+            key.setControllerButton(button);
+            return key;
+        }
+
+        @Override
+        public JsonElement serialize(ModifierKey src, Type typeOfSrc, JsonSerializationContext context) {
+            JsonObject object = new JsonObject();
+            object.addProperty("type", Key.Serializer.KEY_CLASS_TO_ID.get(src.getClass()));
+
+            object.addProperty("x", src.x);
+            object.addProperty("y", src.y);
+            if (src.width != DEFAULT_WIDTH) object.addProperty("width", src.width);
+            if (src.height != DEFAULT_HEIGHT) object.addProperty("height", src.height);
+            if (src.controllerButton != null) object.addProperty("button", src.controllerButton.name().toLowerCase(Locale.ROOT));
+
+            boolean ku = !src.keyUp.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_UP);
+            boolean kd = !src.keyDown.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_DOWN);
+            boolean kuh = !src.keyUpHovered.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_UP_HOVERED);
+            boolean kdh = !src.keyDownHovered.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_DOWN_HOVERED);
+            if (ku || kd || kuh || kdh) {
+                JsonObject textureObject = new JsonObject();
+                if (ku) textureObject.addProperty("up", src.keyUp.sourceNamespaceId.toString());
+                if (kd) textureObject.addProperty("down", src.keyDown.sourceNamespaceId.toString());
+                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.sourceNamespaceId.toString());
+                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.sourceNamespaceId.toString());
+                object.add("textures", textureObject);
+            }
+
+            if (!src.modifierId.equals(DEFAULT_MODIFIER_ID)) object.addProperty("modifier", src.modifierId);
+            if (src.locking != DEFAULT_LOCKING) object.addProperty("toggle", src.locking);
+            return object;
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
index e65fe006f..2731a54a4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
@@ -537,6 +537,24 @@ public class ScreenOptions
 
     @Override
     public void guiSpecificControllerInput(ControllerInput controller) {
+        if(controller.buttonStart.pressedThisFrame()) {
+            this.keyPressed((char)0, Keyboard.KEY_ESCAPE, -1, -1);
+        }
+        if(controller.buttonA.pressedThisFrame()) {
+            this.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 0);
+        }
+        if(controller.buttonA.releasedThisFrame()) {
+            this.mouseReleased((int)controller.cursorX, (int)controller.cursorY, 0);
+        }
+        if(controller.buttonY.pressedThisFrame()) {
+            this.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 1);
+        }
+        if(controller.buttonY.releasedThisFrame()) {
+            this.mouseReleased((int)controller.cursorX, (int)controller.cursorY, 1);
+        }
+        if(controller.buttonX.pressedThisFrame()) {
+            this.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 10);
+        }
         if (controller.buttonB.pressedThisFrame()) {
             mc.displayScreen(getParentScreen());
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/BooleanOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/BooleanOptionComponent.java
index 8d8f00351..588159501 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/BooleanOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/BooleanOptionComponent.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.options.components;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.SwitchElement;
 import net.minecraft.client.option.OptionBoolean;
+import net.minecraft.client.render.window.CursorShape;
 
 public class BooleanOptionComponent
     extends ButtonComponent
@@ -59,5 +60,9 @@ public class BooleanOptionComponent
         this.button.height = buttonHeight;
 
         this.button.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+
+        if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
index 6188b9862..762dff32c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
@@ -4,6 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import org.lwjgl.opengl.GL11;
@@ -99,6 +100,10 @@ public abstract class ButtonComponent
             resetButton.yPosition = y + relativeButtonY;
 
             resetButton.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+
+            if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+                mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+            }
         }
     }
 
